

#include <stdint.h>
#include "pcm.h"


// Mapping of Pin to alternate function for PCM_CLK
const pcm_pin_table_t pcm_pin_clk[] =
{
    {
        .pinnum = 18,
        .altnum = 0,
    },
    {
        .pinnum = 28,
        .altnum = 2,
    },
};

// Mapping of Pin to alternate function for PCM_FS
const pcm_pin_table_t pcm_pin_fs[] =
{
    {
        .pinnum = 19,
        .altnum = 0,
    },
    {
        .pinnum = 29,
        .altnum = 2,
    },
};

// Mapping of Pin to alternate function for PCM_DIN
const pcm_pin_table_t pcm_pin_din[] =
{
    {
        .pinnum = 20,
        .altnum = 0,
    },
    {
        .pinnum = 30,
        .altnum = 2,
    },
};

// Mapping of Pin to alternate function for PCM_DOUT
const pcm_pin_table_t pcm_pin_dout[] =
{
    {
        .pinnum = 21,
        .altnum = 0,
    },
    {
        .pinnum = 31,
        .altnum = 2,
    },
};

const pcm_pin_tables_t pcm_pin_tables[NUM_PCMFUNS] =
{
    {
        .pins = pcm_pin_clk,
        .count = sizeof(pcm_pin_clk) / sizeof(pcm_pin_clk[0]),
    },
    {
        .pins = pcm_pin_fs,
        .count = sizeof(pcm_pin_fs) / sizeof(pcm_pin_fs[0]),
    },
    {
        .pins = pcm_pin_din,
        .count = sizeof(pcm_pin_din) / sizeof(pcm_pin_din[0]),
    },
    {
        .pins = pcm_pin_dout,
        .count = sizeof(pcm_pin_dout) / sizeof(pcm_pin_dout[0]),
    },
};


int pcm_pin_alt(int pcmfun, int pinnum)
{
    if (pcmfun < 0 || pcmfun > 3) {
        return -1;
    }
    const pcm_pin_tables_t *pintable = &pcm_pin_tables[pcmfun];
    int i;

    for (i = 0; i < pintable->count; i++)
    {
        if (pintable->pins[i].pinnum == pinnum)
        {
            return pintable->pins[i].altnum;
        }
    }

    return -1;
}

